#!/bin/sh
set -e

# Source env file
SCRIPT=`readlink -f $0`
SCRIPTDIR=`dirname $SCRIPT`
SCRIPTNAME=`basename $SCRIPT`
ROOTDIR="$SCRIPTDIR/../.."
. $SCRIPTDIR/env.sh


mkdir -p $ROOTDIR/source
if [ ! -f $ROOTDIR/source/geonetwork-3.4.1-0.war ]; then
  cd $ROOTDIR/source
  wget -O geonetwork-3.4.1-0.war https://sourceforge.net/projects/geonetwork/files/GeoNetwork_opensource/v3.4.1/geonetwork.war/download
fi;