# Geosource

## Download dependency
```bash
mkdir source
cd source
wget -O geonetwork-3.10.2-0.war https://sourceforge.net/projects/geonetwork/files/GeoNetwork_opensource/v3.10.2/geonetwork.war/download
cd ..
```

## Build geosource war in local maven repository

```bash
./mvnw install:install-file -DgroupId=org.geonetwork-opensource -DartifactId=geonetwork -Dversion=3.10.2-0 -Dpackaging=war -Dfile=./source/geonetwork-3.10.2-0.war && ./mvnw clean package
```
